//: C02:MemTest.cpp
// Z knihy "Myslíme v jazyce C++, část 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Všechna práva vyhrazena.
// Přečtěte si podmínky používání zdrojových kódů umístěné v souboru 
// 'Licence.txt' dodávaném spolu s balíčkem kódu dostupným na www.MindView.net.
// Test systému MemCheck.
//{L} MemCheck
#include <iostream>
#include <vector>
#include <cstring>
#include "MemCheck.h"   // Musí být na posledním místě!
using namespace std;

class Neco {
  char* s;
public:
  Neco(const char*s ) {
    this->s = new char[strlen(s) + 1];
    strcpy(this->s, s);
  }
  ~Neco() { delete [] s; }
};

int main() {
  MEM_ON();
  cout << "Ahoj" << endl;
  int* p = new int;
  delete p;
  int* q = new int[3];
  delete [] q;
  int* r;
  delete r;
  vector<int> v;
  v.push_back(1);
  Neco s("Nashledanou");
  MEM_OFF();
} ///:~
